/* application source */
var canvas = document.getElementById("skeletonsCanvas");
var context = canvas.getContext("2d");

function getSkeletons(jsonObject) {

    if (context == null) {
        return;
    }

    context.clearRect(0, 0, canvas.width, canvas.height);

    for (var i = 0; i < jsonObject.skeletons.length; i++) {
        var headZ = 0;
        var hipZ = 0;

        for (var j = 0; j < jsonObject.skeletons[i].joints.length; j++)
        {
            var joint = jsonObject.skeletons[i].joints[j];

            // Draw!!!
            context.fillStyle = "#FF0000";
            context.beginPath();
            context.arc(joint.x, joint.y, 10, 0, Math.PI * 2, true);
            context.closePath();
            context.fill();

            // joint.name  values
            //head
            //hipleft

        }
    }
}


function msgFromArduino(value) {
    console.debug('From Arduino: ' + value);
}

function next() {
    if (isNotHome()) {
        $('.fp-prev').click();
    }
}

function prior() {
    if (isNotHome()) {
        $('.fp-next').click();
    }
}

function isNotHome() {
    var elementName = $('#menu').find('li.active').first().attr('data-menuanchor');
    return elementName != 'Home';
}

function noUser() {
    console.debug('No User :(');
//sendToArduino('0');

}

function newUser() {
    console.debug('New User :)');
    //sendToArduino('1');
}

function changeHandNone() {
    console.debug('Hand None');
}

function changeHandRight() {
    console.debug('Hand Right');
}

function changeHandLeft() {
    console.debug('Hand Left');
}





ubiquo = function () {
    var controls = {
        click: "Ubi---click",
        loaded: "Ubi---loaded"
    };

    var cursorInterval;
    var cursorIntervalWidth = 0;
    var cursorStart = function () {
        var LoadingExists = document.getElementById("ubiCursorLoading");

        if (LoadingExists === null) {
            var body = document.getElementsByTagName("body").item(0);
            var myDiv = document.createElement("div");
            myDiv.id = "ubiCursorLoading";
            myDiv.style.position = "fixed";
            myDiv.style.bottom = "0px";
            myDiv.style.right = "0px";
            myDiv.style.width = "0px";
            myDiv.style.height = "30px";
            myDiv.style.zIndex = "99999";
            myDiv.style.backgroundColor = "black";

            body.appendChild(myDiv);
        }
        cursorInterval = setInterval(function () {
            cursorIntervalWidth += 1;
            var LoadingExists = document.getElementById("ubiCursorLoading");
            LoadingExists.style.width = cursorIntervalWidth + "%";

        }, 20);

    };

    var cursorEnd = function () {
        var LoadingExists = document.getElementById("ubiCursorLoading");
        cursorIntervalWidth = 0;
        clearTimeout(cursorInterval);
        LoadingExists.style.width = cursorIntervalWidth + "px";

    };



    var hasClass = function (element, cls) {
        return (' ' + element.className + ' ').indexOf(' ' + cls + ' ') > -1;
    };

    function eventFire(el, etype) {
        if (el.fireEvent) {
            el.fireEvent('on' + etype);
        } else {
            var evObj = document.createEvent('Events');
            evObj.initEvent(etype, true, false);
            el.dispatchEvent(evObj);
        }
    }

    var prepareClick = function (element) {
        cursorStart();
        this.ubiready = setTimeout(function (that) {

            return function () {
                eventFire(that, "click");
                cursorEnd();
            };
        }(this), 400);
    };



    var loadMouseOver = function (element) {

        element.addEventListener("mouseover", function () {
            prepareClick.apply(this);
        });
        element.addEventListener("mouseout", function () {
            clearTimeout(this.ubiready);
            cursorEnd();
        });
    };

    var initEvent = function (elements) {
        for (var i in elements) {
            if (!hasClass(elements[i], controls.loaded) && typeof elements[i] === "object") {
                elements[i].className = elements[i].className + " " + controls.loaded;
                loadMouseOver(elements[i]);
            }
        }
    };

    var load = function () {
        var elementCollection = document.getElementsByClassName(controls.click);
        initEvent(elementCollection);
    };

    return{
        load: load
    };

}();

var hideMenu;
var showMenu;



var currentNews = 1;
var maxNews = 6;

function nextNews() {
    setInterval(function () {
        nextNew = currentNews + 1;
        if (nextNew === maxNews) {
            nextNew = 1;
        }

        toSlide = $("#noticia" + nextNew);
        fromSlide = $('.noticia.active');
        toSlide.addClass('active');
        fromSlide.removeClass('actrive');
        fromSlide.fadeOut("slow");
        toSlide.fadeIn("slow");
        currentNews = nextNew;
    }, 10000);
}

var menuTimeoutArray = [];



loadHtmlElements = function () {
    $.getJSON("http://dev.easy-code.com/slides/web/api/get-slide?token=test", function (JsonParams) {


        /**
         * Crea una noticia en la portada.
         * 
         * @param {string} titulo
         * @param {string} contenido
         * @returns {undefined}
         */
        function crearNoticia(titulo, contenido, index) {
            active = '';
//        activeCss = 'style="display:none;"';
            activeCss = '';
            if (index === 1) {
                active = 'active';
                activeCss = '';
            }
            htmlData = '<div id="noticia' + index + '" class="noticia ' + active + '" ' + activeCss + '>\n\
                    <h4>' + titulo + '</h4>\n\
                    <p>' + contenido + '</p>\n\
                    </div>';
            $('#section0 .news .feed').append(htmlData);
        }

        /**
         * Crea un boton del menú superior y sus anchor.
         * @param {type} id
         * @param {type} catNombre
         * @returns {undefined}
         */
        function crearMenu(catId, catNombre) {
            $('#menu').append('<li data-menuanchor="' + catId + '"><a href="#' + catId + '" class="Ubi---click">' + catNombre + '</a></li>');

        }

        /**
         * 
         * @param {string} catId
         * @param {objet} catDatos
         * @param {integer} sectionCount
         * @returns {undefined}
         */
        function crearCategoria(catId, catDatos, sectionCount) {
            $('#fullpage').append('<div class="section" id="section' + sectionCount + '" >\n\
                    <div class="serietitle">' + catDatos.nombre + '</div>\n\
</div>');
            htmlData = '<div  id="0" class="slide">\n\
                    <div class="catDescription">' + catDatos.descripcion + '\n\
                    </div>\n\
                </div>';
            $('#section' + sectionCount).append(htmlData);
        }

        /**
         * Crea un producto en una categoría.
         * 
         * @param {string} catId
         * @param {string} productCount
         * @param {objet} prodData
         * @returns {undefined}
         */
        function crearProducto(catId, catCount, productCount, prodData, catName) {

            var htmlProductData = ''
            $.each(prodData.datos, function (j, elem) {
                htmlProductData += '<div class="dato"><b>' + j + '</b><br/>' + elem + '</div>';
            });
            //todo: imagen de producto
            htmlData = '<div  id="' + productCount + '" class="slide">\n\
                    <div class="intro">\n\
                        <div class="leftPartSlide">\n\
                            <img src="' + prodData.imagen + '" alt="Cool" />\n\
                        </div>\n\
                        <div  class="rightPartSlide">\n\
                            <h1>' + prodData.nombre + '</h1>\n\
                            <div>' + htmlProductData + '</div>\n\
                        </div>\n\
                    </div>\n\
                    <div id="productQR' + productCount + 'cat' + catCount + '" class="productQR">\n\
                    </div>\n\
                </div>';
            $('#section' + catCount).append(htmlData);
            $('#productQR' + productCount + 'cat' + catCount).qrcode({
                "render": "div",
                "size": 100,
                "color": "#3a3",
                "text": prodData.url
            });
            if (prodData.destacado) {
                destacadoHtmlData = '<a href="#" class="Ubi---click" onclick="hideMenu();$.fn.fullpage.moveTo(\'' + catId + '\', ' + productCount + ');">\n\
                        <div class="item">\n\
                            <img src ="' + prodData.imagenDestacado + '"/>\n\
                            <div class="text">\n\
                                ' + prodData.nombre + '\n\
                            </div>\n\
                        </div>\n\
                    </a>'
                $('#section0 .contents').append(destacadoHtmlData);
            }
        }

        document.title = JsonParams.cliente.datos.titulo;

        var anchorsArray = ['Home'];
        var sectionsColorsArray = ['white'];

        var noticiasCount = 1;
        $.each(JsonParams.cliente.noticias, function (i, item) {
            crearNoticia(item.titulo, item.contenido, noticiasCount);
            noticiasCount += 1;
        });
        var familiasCount = 1;
        $.each(JsonParams.cliente.familias, function (i, item) {
            anchorsArray.push(i);
            sectionsColorsArray.push('white');
            crearMenu(i, item.datos.nombre);
            crearCategoria(i, item.datos, familiasCount);
            var productosCount = 1;
            $.each(item.productos, function (j, elem) {
                crearProducto(i, familiasCount, productosCount, elem, item.datos.nombre);
                productosCount += 1;
            });
            familiasCount += 1;
        });

        $('#fullpage').fullpage({
            sectionsColor: sectionsColorsArray,
            controlArrowColor: 'darkblue',
            anchors: anchorsArray,
            menu: '#menu',
            loopHorizontal: false,
            slidesNavigation: true,
            scrollingSpeed: 700,
            css3: true,
            easing: 'easeOutExpo',
            //Hide the slides container before the next slide loads
            onSlideLeave: function (anchorLink, index, slideIndex, direction) {
                //    $('.fp-section').hide();
            },
            // Display the slides container by fading it in after the next slide has been loaded.
            afterSlideLoad: function (anchorLink, index, slideAnchor, slideIndex) {
                //    $('.fp-section').fadeIn(700);
            },
            onLeave: function (index, nextIndex, direction) {
                if(nextIndex !== 1){                     
                    $('#menu li a ').css("color","darkblue");  
                    $('#app-logo').css("opacity","1");
                    $('#app-logo').css("color","rgba(0, 0, 139,1)");
                    $('#app-logo a').css("color","rgba(0, 0, 139,1)");
                    
//                    $('#menu li a ').css("color","rgba(0, 0, 139,0.2)");
                    $('#menu-toggle li a').css("background-image","url(images/menu.png)");
//                    $('#menu-toggle li').css("opacity","0.2");
                  //  $('#menu-toggle li').css("background","darkblue");

                }
                $('.fp-section').hide();
            },
            afterLoad: function (anchorLink, index) {
                if(index === 1){
                    
                    $('#menu li a ').css("color","whitesmoke");
                    $('#app-logo').css("color","whitesmoke");
            $('#app-logo').css("opacity","1");
                    $('#app-logo a').css("color","whitesmoke");
                   // $('#menu-toggle li a').css("color","darkblue");
                    $('#menu-toggle li a').css("background-image","url(images/menu_white.png)");
                    
//                    $('#menu-toggle li').css("opacity","1");
                  //  $('#menu-toggle li').css("background","whitesmoke");
                }
                $('.fp-section').fadeIn(700);

            }
//        easing:'fade',
            // easingcss3:'easeOutExpo'
            //easingcss3: 'cubic-bezier(0.175, 0.885, 0.320, 1.275)'

        });
//    nextNews();

        $(".fp-controlArrow.fp-prev, .fp-controlArrow.fp-next").addClass("Ubi---click");
        ubiquo.load();


        $.fn.mySlider = function () {
            $('#mycursor').show();
            //$('#mycursor').css("background-image", "url('http://www.clker.com/cliparts/L/a/9/2/H/N/pointer-hand-mouse-hi.png')");
            $('#mycursor').css("background-color", "rgba(200,200,255,0.7)");
            $('#mycursor').css("border-radius", "50px");
            $('body').mousemove(function (e) {

                $('#mycursor').css('left', e.clientX + 17).css('top', e.clientY + 45);

                if ({parameter: 26} === 1)
                {
                    $('h1').text(e.clientX);
                }
            });

            $("body a, .fp-controlArrow").mouseenter(function () {

                $("#mycursor").stop(true);
                $("#mycursor").animate({
                    width: '75px',
                    height: '75px'
                }, 1, function () {
                    // Animation complete.
                });
                $("#mycursor").animate({
                    width: '100px',
                    height: '100px'
                }, 400, function () {
                    // Animation complete.
                });
            });
            $("body a, .fp-controlArrow").mouseleave(function () {

                $("#mycursor").animate({
                    width: '75px',
                    height: '75px'
                }, 50, function () {
                    // Animation complete.
                });
            });
            $("body a, .fp-controlArrow").click(function () {
                $("#mycursor").animate({
                    width: '75px',
                    height: '75px'
                }, 300, function () {
                    // Animation complete.
                });
                
                

                    $(this).animate({
                opacity: '0.2'
                    }, 200, function () {
                        // Animation complete.
                    });
                    $(this).animate({
                opacity: '0.3'
                    }, 1000, function () {
                        // Animation complete.
                    });
                    $(this).animate({
                opacity: '1'
                    }, 200, function () {
                        // Animation complete.
                    });
                
            });
        };


        $("body").mySlider();

        if ({parameter: 26} == 0)
        {
            $('h1').hide();

        }
        $('#app-logo a').click(function(){
            
            $('#app-logo').css("opacity","0.5");
        });
        $('#menu-toggle a').click(function () {
            $("#menu-toggle li").animate({
                width: '80px',
                height: '80px'
            }, 100, function () {
                // Animation complete.
            });
            $("#menu-toggle li").animate({
                width: '70px',
                height: '70px'
            }, 100, function () {
                // Animation complete.
            });
            $("#menu-toggle li").animate({
                width: '75px',
                height: '75px'
            }, 100, function () {
                // Animation complete.
            });
            showMenu();
        });
        $('#menu .Ubi---click').click(function () {
            hideMenu();
        });
        hideMenu = function () {
            $.each(menuTimeoutArray, function (index, value) {
                clearTimeout(value);
            });

            increment = 0;
            $('#menu li').each(function (index, value) {

                timeout = setTimeout(function () {
                    $(value).fadeOut(500);
                },
                        5000 + increment);
                increment -= 250;

                menuTimeoutArray.push(timeout);
            });

            timeout = setTimeout(function () {
                $('#menu').hide();
                $('#menu-toggle li').css("opacity","1");
            },
                    5500);
            menuTimeoutArray.push(timeout);
        };
        showMenu = function () {

            $('#menu li').each(function (index, value) {
                $(value).show();
            });  
            $('#menu-toggle li').css("opacity","0.2");
            $('#menu').show("slide", {direction: "left"}, 500);
        };
    });
    $('#loading').fadeOut(1000);
};
    